# User Exports

To create an archive of user data.


## Request user export

`POST /api/v1/users/{userId}/exports/request`

Request an archive of user data. An email is sent when the archive is ready.

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": []
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started


Parameters:

- `userId` (path, id, required) - User id
  Type: id
  
  Schema: [id](https://docs.joinpeertube.org/api-rest-reference/api/models/id.md)
  
  minimum: 1
  
  Example:
  
  ```json
  42
  ```

Request body: application/json

Type: object

- `withVideoFiles` (optional)
  Type: boolean
  
  Whether to include video files in the archive

Responses:

- 200: successful operation

Content type: application/json

Type: object

- `export` (optional)
  Type: object
  
  - `id` (optional)
    Type: integer

## Examples

### cURL

```bash
curl -X POST 'https://peertube2.cpy.re/api/v1/users/42/exports/request' \
  -H 'Authorization: Bearer YOUR_TOKEN' \
  -H 'Content-Type: application/json' \
  --data-raw '{
  "withVideoFiles": true
}'
```

### JavaScript

```javascript
const body = `{
  "withVideoFiles": true
}`;

const response = await fetch('https://peertube2.cpy.re/api/v1/users/42/exports/request', {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
    'Content-Type': 'application/json',
  },
  body,
});

const data = await response.text();
```

### Python

```python
import requests

body = '''{
  "withVideoFiles": true
}'''

response = requests.post(
    'https://peertube2.cpy.re/api/v1/users/42/exports/request',
    data=body.encode('utf-8'),
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
        'Content-Type': 'application/json',
    },
)
print(response.text)
```


## List user exports

`GET /api/v1/users/{userId}/exports`

**PeerTube >= 6.1**

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": []
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started


Parameters:

- `userId` (path, id, required) - User id
  Type: id
  
  Schema: [id](https://docs.joinpeertube.org/api-rest-reference/api/models/id.md)
  
  minimum: 1
  
  Example:
  
  ```json
  42
  ```

Responses:

- 200: successful operation

Content type: application/json

Type: object

- `id` (optional)
  Type: integer

- `state` (optional)
  Type: object
  
  - `id` (optional)
    Reference: [UserExportState](https://docs.joinpeertube.org/api-rest-reference/api/models/userexportstate.md); Type: UserExportState
    
    The user export state:
      - `1`: Pending
      - `2`: Processing
      - `3`: Completed
      - `4`: Errored
    
    
    enum: [1,2,3,4]
  
  - `label` (optional)
    Type: string

- `size` (optional)
  Type: integer
  
  Size of the archive file in bytes

- `privateDownloadUrl` (optional)
  Type: string
  
  This URL already contains the JWT token, so no additional authentication credentials are required

- `createdAt` (optional)
  Type: string, date-time

- `expiresOn` (optional)
  Type: string, date-time

## Examples

### cURL

```bash
curl -X GET 'https://peertube2.cpy.re/api/v1/users/42/exports' \
  -H 'Authorization: Bearer YOUR_TOKEN'
```

### JavaScript

```javascript
const response = await fetch('https://peertube2.cpy.re/api/v1/users/42/exports', {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
  },
});

const data = await response.text();
```

### Python

```python
import requests

response = requests.get(
    'https://peertube2.cpy.re/api/v1/users/42/exports',
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
    },
)
print(response.text)
```


## Delete a user export

`DELETE /api/v1/users/{userId}/exports/{id}`

**PeerTube >= 6.1**

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": []
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started


Parameters:

- `userId` (path, id, required) - User id
  Type: id
  
  Schema: [id](https://docs.joinpeertube.org/api-rest-reference/api/models/id.md)
  
  minimum: 1
  
  Example:
  
  ```json
  42
  ```

- `id` (path, id, required) - Entity id
  Type: id
  
  Schema: [id](https://docs.joinpeertube.org/api-rest-reference/api/models/id.md)
  
  minimum: 1
  
  Example:
  
  ```json
  42
  ```

Responses:

- 204: successful operation

## Examples

### cURL

```bash
curl -X DELETE 'https://peertube2.cpy.re/api/v1/users/42/exports/42' \
  -H 'Authorization: Bearer YOUR_TOKEN'
```

### JavaScript

```javascript
const response = await fetch('https://peertube2.cpy.re/api/v1/users/42/exports/42', {
  method: 'DELETE',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
  },
});

const data = await response.text();
```

### Python

```python
import requests

response = requests.delete(
    'https://peertube2.cpy.re/api/v1/users/42/exports/42',
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
    },
)
print(response.text)
```
